Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/cpdet_mod.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/cpdet_mod.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3d_common/cpdet_mod.F90	(revision 227)
@@ -142,4 +142,5 @@
 ! Parallel version of t2tpot, for an arbitrary number of columns
       USE control_mod, only : planet_type
+      USE parallel_lmdz, only : OMP_CHUNK
       IMPLICIT none
 
@@ -179,5 +180,5 @@
 ! Parallel version of t2tpot, over the full dynamics (scalar) grid
 ! (more efficient than multiple calls to t2tpot_p() with slices of data)
-      USE parallel_lmdz, only : jj_begin,jj_end
+      USE parallel_lmdz, only : jj_begin,jj_end,OMP_CHUNK
       USE control_mod, only : planet_type
       IMPLICIT none
@@ -223,4 +224,5 @@
 ! Parallel version of tpot2t, for an arbitrary number of columns
       USE control_mod, only : planet_type
+      USE parallel_lmdz, only : OMP_CHUNK
       IMPLICIT none
 ! for cpp, nu_venus and t0_venus:
@@ -259,5 +261,5 @@
 ! Parallel version of tpot2t, over the full dynamics (scalar) grid
 ! (more efficient than multiple calls to tpot2t_p() with slices of data)
-      USE parallel_lmdz, only : jj_begin,jj_end
+      USE parallel_lmdz, only : jj_begin,jj_end,OMP_CHUNK
       USE control_mod, only : planet_type
       IMPLICIT none
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/gcm.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/gcm.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/gcm.F	(revision 227)
@@ -599,5 +599,8 @@
 c       write(78,*) 'q',q
 
-c$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logici/,/logicl/)
+!c$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logici/,/logicl/)
+!variable temps no longer exists
+c$OMP PARALLEL DEFAULT(SHARED)
+c$OMP1 COPYIN(/temps_r/,/temps_i/,/temps_c/,/logici/,/logicl/)
       CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,
      .              time_0)
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/sponge_mod_p.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/sponge_mod_p.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/dyn3dpar/sponge_mod_p.F90	(revision 227)
@@ -31,5 +31,5 @@
 
       USE Write_Field_p
-      use parallel_lmdz, only: pole_sud,pole_nord,jj_begin,jj_end
+      use parallel_lmdz, only: pole_sud,pole_nord,jj_begin,jj_end,OMP_CHUNK
       implicit none
 #include "dimensions.h"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeropacity.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeropacity.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeropacity.F90	(revision 227)
@@ -30,6 +30,6 @@
 !     pq                Aerosol mixing ratio
 !     reffrad(ngrid,nlayer,naerkind)         Aerosol effective radius
-!     QREFvis3d(ngrid,nlayermx,naerkind) \ 3d extinction coefficients
-!     QREFir3d(ngrid,nlayermx,naerkind)  / at reference wavelengths
+!     QREFvis3d(ngrid,nlayer,naerkind) \ 3d extinction coefficients
+!     QREFir3d(ngrid,nlayer,naerkind)  / at reference wavelengths
 !
 !     Output
@@ -40,9 +40,9 @@
 !=======================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 #include "comcstfi.h"
-#include "comvert.h"
+!#include "comvert.h"
 
       INTEGER,INTENT(IN) :: ngrid  ! number of atmospheric columns
@@ -54,9 +54,9 @@
       REAL,INTENT(OUT) :: aerosol(ngrid,nlayer,naerkind) ! aerosol optical depth
       REAL,INTENT(IN) :: reffrad(ngrid,nlayer,naerkind) ! aerosol effective radius
-      REAL,INTENT(IN) :: QREFvis3d(ngrid,nlayermx,naerkind) ! extinction coefficient in the visible
-      REAL,INTENT(IN) :: QREFir3d(ngrid,nlayermx,naerkind)
+      REAL,INTENT(IN) :: QREFvis3d(ngrid,nlayer,naerkind) ! extinction coefficient in the visible
+      REAL,INTENT(IN) :: QREFir3d(ngrid,nlayer,naerkind)
       REAL,INTENT(OUT):: tau_col(ngrid) !column integrated visible optical depth
       ! BENJAMIN MODIFS
-      real,intent(in) :: cloudfrac(ngrid,nlayermx) ! cloud fraction
+      real,intent(in) :: cloudfrac(ngrid,nlayer) ! cloud fraction
       real,intent(out) :: totcloudfrac(ngrid) ! total cloud fraction
       logical,intent(in) :: clearsky
@@ -67,4 +67,5 @@
 
       LOGICAL,SAVE :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall)
       REAL CBRT
       EXTERNAL CBRT
@@ -72,4 +73,5 @@
       INTEGER,SAVE :: i_co2ice=0      ! co2 ice
       INTEGER,SAVE :: i_h2oice=0      ! water ice
+!$OMP THREADPRIVATE(i_co2ice,i_h2oice)
       CHARACTER(LEN=20) :: tracername ! to temporarily store text
 
@@ -135,10 +137,10 @@
            iaer=iaero_co2
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
             if (noaero) then ! aerosol set to zero
-             aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+             aerosol(1:ngrid,1:nlayer,iaer)=0.0
             elseif (aerofixco2.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
-               aerosol(1:ngrid,1:nlayermx,iaer)=1.e-9
+               aerosol(1:ngrid,1:nlayer,iaer)=1.e-9
                !aerosol(1:ngrid,12,iaer)=4.0 ! single cloud layer option
             else
@@ -172,8 +174,8 @@
            iaer=iaero_h2o
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
             if (aerofixh2o.or.(i_h2oice.eq.0).or.clearsky) then
-               aerosol(1:ngrid,1:nlayermx,iaer) =1.e-9
+               aerosol(1:ngrid,1:nlayer,iaer) =1.e-9
 
                ! put cloud at cloudlvl
@@ -226,5 +228,5 @@
 
                if(CLFvarying)then
-                  call totalcloudfrac(ngrid,nq,cloudfrac,totcloudfrac,pplev,pq,aerosol(1:ngrid,1:nlayermx,iaer))
+                  call totalcloudfrac(ngrid,nlayer,nq,cloudfrac,totcloudfrac,pplev,pq,aerosol(1,1,iaer))
                   do ig=1, ngrid
                      do l=1,nlayer-1 ! to stop the rad tran bug
@@ -253,5 +255,5 @@
           iaer=iaero_dust
 !         1. Initialization 
-          aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+          aerosol(1:ngrid,1:nlayer,iaer)=0.0
           
           topdust=30.0 ! km  (used to be 10.0 km) LK
@@ -264,5 +266,5 @@
 !             Typical mixing ratio profile
 
-                 zp=(preff/pplay(ig,l))**(70./topdust)
+                 zp=(pplev(ig,1)/pplay(ig,l))**(70./topdust)
                  expfactor=max(exp(0.007*(1.-max(zp,1.))),1.e-3)
 
@@ -277,6 +279,5 @@
 !          Rescaling each layer to reproduce the choosen (or assimilated)
 !          dust extinction opacity at visible reference wavelength, which
-!          is scaled to the "preff" reference surface pressure available in comvert.h
-!          and stored in startfi.nc
+!          is scaled to the surface pressure pplev(ig,1)
 
             taudusttmp(1:ngrid)=0.
@@ -291,5 +292,5 @@
                   aerosol(ig,l,iaer) = max(1E-20, &
                           dusttau &
-                       *  pplev(ig,1) / preff &
+                       *  pplev(ig,1) / pplev(ig,1) &
                        *  aerosol(ig,l,iaer) &
                        /  taudusttmp(ig))
@@ -307,5 +308,5 @@
 
 !       1. Initialization
-         aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+         aerosol(1:ngrid,1:nlayer,iaer)=0.0
 
 
@@ -317,5 +318,5 @@
 !              Typical mixing ratio profile
 
-               zp=(preff/pplay(ig,l))**(70./30) !emulating topdust
+               zp=(pplev(ig,1)/pplay(ig,l))**(70./30) !emulating topdust
                expfactor=max(exp(0.007*(1.-max(zp,1.))),1.e-3)
 
@@ -335,5 +336,5 @@
                aerosol(ig,l,iaer) = max(1E-20, &
                           1 &
-                       *  pplev(ig,1) / preff &
+                       *  pplev(ig,1) / pplev(ig,1) &
                        *  aerosol(ig,l,iaer) &
                        /  tauh2so4tmp(ig))
@@ -367,5 +368,5 @@
            iaer=iaero_back2lay
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
           DO ig=1,ngrid
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeroptproperties.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeroptproperties.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aeroptproperties.F90	(revision 227)
@@ -32,6 +32,6 @@
 !     ==============================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 
@@ -60,5 +60,5 @@
       INTEGER :: grid_i,grid_j
 !     Intermediate variable
-      REAL :: var_tmp,var3d_tmp(ngrid,nlayermx)
+      REAL :: var_tmp,var3d_tmp(ngrid,nlayer)
 !     Bilinear interpolation factors
       REAL :: kx,ky,k1,k2,k3,k4
@@ -67,4 +67,5 @@
 !     Pi!
       REAL,SAVE :: pi
+!$OMP THREADPRIVATE(pi)
 !     Variables used by the Gauss-Legendre integration:
       INTEGER radius_id,gausind
@@ -87,4 +88,5 @@
                       0.08327674160932,0.06267204829828, &
                       0.04060142982019,0.01761400714091/
+!$OMP THREADPRIVATE(radgaus,weightgaus)
 !     Indices
       INTEGER :: i,j,k,l,m,iaer,idomain
@@ -102,4 +104,5 @@
 !     Grid used to remember which calculation is done
       LOGICAL,SAVE :: checkgrid(refftabsize,nuefftabsize,naerkind,2) = .false.
+!$OMP THREADPRIVATE(refftab,nuefftab,logvratgrid,vratgrid,checkgrid)
 !     Optical properties of the grid (VISIBLE)
       REAL,SAVE :: qsqrefVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
@@ -108,4 +111,5 @@
       REAL,SAVE :: omegVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
       REAL,SAVE :: gVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
+!$OMP THREADPRIVATE(qsqrefVISgrid,qextVISgrid,qscatVISgrid,omegVISgrid,gVISgrid)
 !     Optical properties of the grid (INFRARED)
       REAL,SAVE :: qsqrefIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
@@ -114,4 +118,5 @@
       REAL,SAVE :: omegIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
       REAL,SAVE :: gIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
+!$OMP THREADPRIVATE(qsqrefIRgrid,qextIRgrid,qscatIRgrid,omegIRgrid,gIRgrid)
 !     Optical properties of the grid (REFERENCE WAVELENGTHS)
       REAL,SAVE :: qrefVISgrid(refftabsize,nuefftabsize,naerkind)
@@ -121,13 +126,18 @@
       REAL,SAVE :: omegrefVISgrid(refftabsize,nuefftabsize,naerkind)
       REAL,SAVE :: omegrefIRgrid(refftabsize,nuefftabsize,naerkind)
+!$OMP THREADPRIVATE(qrefVISgrid,qscatrefVISgrid,qrefIRgrid,qscatrefIRgrid,omegrefVISgrid,&
+	!$OMP omegrefIRgrid)
 !     Firstcall
       LOGICAL,SAVE :: firstcall = .true.
+!$OMP THREADPRIVATE(firstcall)
 !     Variables used by the Gauss-Legendre integration:
       REAL,SAVE :: normd(refftabsize,nuefftabsize,naerkind,2)
       REAL,SAVE :: dista(refftabsize,nuefftabsize,naerkind,2,ngau)
       REAL,SAVE :: distb(refftabsize,nuefftabsize,naerkind,2,ngau)
+!$OMP THREADPRIVATE(normd,dista,distb)
 
       REAL,SAVE :: radGAUSa(ngau,naerkind,2)
       REAL,SAVE :: radGAUSb(ngau,naerkind,2)
+!$OMP THREADPRIVATE(radGAUSa,radGAUSb)
 
       REAL,SAVE :: qsqrefVISa(L_NSPECTV,ngau,naerkind)
@@ -141,4 +151,6 @@
       REAL,SAVE :: gVISa(L_NSPECTV,ngau,naerkind)
       REAL,SAVE :: gVISb(L_NSPECTV,ngau,naerkind)
+!$OMP THREADPRIVATE(qsqrefVISa,qrefVISa,qsqrefVISb,qrefVISb,omegVISa, &
+	!$OMP omegrefVISa,omegVISb,omegrefVISb,gVISa,gVISb)
 
       REAL,SAVE :: qsqrefIRa(L_NSPECTI,ngau,naerkind)
@@ -152,4 +164,6 @@
       REAL,SAVE :: gIRa(L_NSPECTI,ngau,naerkind)
       REAL,SAVE :: gIRb(L_NSPECTI,ngau,naerkind)
+!$OMP THREADPRIVATE(qsqrefIRa,qrefIRa,qsqrefIRb,qrefIRb,omegIRa,omegrefIRa,&
+	!$OMP omegIRb,omegrefIRb,gIRa,gIRb)
 
       REAL :: radiusm
@@ -161,24 +175,24 @@
       INTEGER :: ngrid,nlayer
 !     Aerosol effective radius used for radiative transfer (meter)
-      REAL :: reffrad(ngrid,nlayermx,naerkind)
+      REAL,INTENT(IN) :: reffrad(ngrid,nlayer,naerkind)
 !     Aerosol effective variance used for radiative transfer (n.u.)
-      REAL :: nueffrad(ngrid,nlayermx,naerkind)
+      REAL,INTENT(IN) :: nueffrad(ngrid,nlayer,naerkind)
 
 !     Outputs
 !     -------
 
-      REAL :: QVISsQREF3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: omegaVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: gVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-
-      REAL :: QIRsQREF3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: omegaIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: gIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-
-      REAL :: QREFvis3d(ngrid,nlayermx,naerkind)
-      REAL :: QREFir3d(ngrid,nlayermx,naerkind)
-
-      REAL :: omegaREFvis3d(ngrid,nlayermx,naerkind)
-      REAL :: omegaREFir3d(ngrid,nlayermx,naerkind)
+      REAL,INTENT(OUT) :: QVISsQREF3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL,INTENT(OUT) :: omegaVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL,INTENT(OUT) :: gVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+
+      REAL,INTENT(OUT) :: QIRsQREF3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL,INTENT(OUT) :: omegaIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL,INTENT(OUT) :: gIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+
+      REAL,INTENT(OUT) :: QREFvis3d(ngrid,nlayer,naerkind)
+      REAL,INTENT(OUT) :: QREFir3d(ngrid,nlayer,naerkind)
+
+      REAL :: omegaREFvis3d(ngrid,nlayer,naerkind)
+      REAL :: omegaREFir3d(ngrid,nlayer,naerkind)
 
       DO iaer = 1, naerkind ! Loop on aerosol kind
@@ -724,5 +738,5 @@
                         k2*omegrefIRgrid(grid_i+1,1,iaer)
           ENDIF                  ! --------------------------------
-        ENDDO !nlayermx
+        ENDDO !nlayer
       ENDDO !ngrid
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aerosol_mod.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aerosol_mod.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/aerosol_mod.F90	(revision 227)
@@ -16,4 +16,5 @@
 ! two-layer simple aerosol model
       integer :: iaero_back2lay = 0
+!$OMP THREADPRIVATE(iaero_co2,iaero_h2o,iaero_dust,iaero_h2so4,noaero,iaero_back2lay)
       
 !==================================================================
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/ave_stelspec.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/ave_stelspec.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/ave_stelspec.F90	(revision 227)
@@ -38,5 +38,5 @@
       integer ifine
 
-      real,allocatable :: lam(:),stel_f(:)
+      real,allocatable,save :: lam(:),stel_f(:) 	!read by master
       real band,lamm,lamp
       real dl
@@ -116,4 +116,5 @@
          End Select
 
+!$OMP MASTER
 	 allocate(lam(Nfine),stel_f(Nfine))
 
@@ -153,4 +154,6 @@
            close(111)
          endif
+!$OMP END MASTER
+!$OMP BARRIER
 	 
          ! sum data by band
@@ -173,6 +176,10 @@
 	 
          STELLAR(1:L_NSPECTV)=STELLAR(1:L_NSPECTV)/sum(STELLAR(1:L_NSPECTV))
-         deallocate(lam,stel_f)
-         
+!$OMP BARRIER
+!$OMP MASTER
+	 if (allocated(lam)) deallocate(lam)
+	 if (allocated(stel_f)) deallocate(stel_f)
+!$OMP END MASTER
+!$OMP BARRIER         
       endif
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/bilinearbig.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/bilinearbig.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/bilinearbig.F90	(revision 227)
@@ -14,4 +14,5 @@
       real*8 f2d_arr(nX,nY)
       real*8,save :: x,y
+!$OMP THREADPRIVATE(x,y)
 
       integer strlen
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_cpp_mugaz.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_cpp_mugaz.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calc_cpp_mugaz.F90	(revision 227)
@@ -20,6 +20,6 @@
       implicit none
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calcenergy_kcm.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calcenergy_kcm.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/calcenergy_kcm.F90	(revision 227)
@@ -1,3 +1,3 @@
-subroutine calcenergy_kcm(Tsurf,T,Play,Plev,Qsurf,Q,muvar,Eatmtot)
+subroutine calcenergy_kcm(nlayer,Tsurf,T,Play,Plev,Qsurf,Q,muvar,Eatmtot)
 
 
@@ -11,6 +11,6 @@
 !     ----------------------------------------------------------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 !#include "callkeys.h"
@@ -19,8 +19,9 @@
 
   ! inputs
-  real Tsurf,T(1:nlayermx)
-  real Play(1:nlayermx),Plev(1:nlayermx+1)
-  real Qsurf,Q(1:nlayermx)
-  real muvar(1,nlayermx+1)
+  integer,intent(in) :: nlayer
+  real Tsurf,T(1:nlayer)
+  real Play(1:nlayer),Plev(1:nlayer+1)
+  real Qsurf,Q(1:nlayer)
+  real muvar(1,nlayer+1)
 
   ! internal
@@ -29,5 +30,5 @@
   real s_c,rho_v,L
   double precision p_v, s_v, nul
-  real VMR(1:nlayermx)
+  real VMR(1:nlayer)
 
   ! output
@@ -41,5 +42,5 @@
 
 
-  do il=1,nlayermx
+  do il=1,nlayer
      VMR(il)=Q(il)*(muvar(1,il+1)/mH2O)
   end do
@@ -47,5 +48,5 @@
 
   Eatmtot = 0.0
-  do il=1,nlayermx
+  do il=1,nlayer
 
 
